//---------------------------------------------------------------------------
#include <vcl.h>
#include <comctrls.hpp>
#pragma hdrstop
USERES("EditorHack3.res");
USEPACKAGE("VCL35.bpi");
//---------------------------------------------------------------------------
#pragma package(smart_init)

class TEditorHack
{
private:
  //New menu item
  TMenuItem *FEditorItem;
protected:
  //Event handler for new menu item
  void __fastcall DoEditorItemClick(TObject *Sender);
  //Routine that changes the state of the editor window
  void __fastcall SetEditorItem(Boolean Value);
public:
  __fastcall TEditorHack();
  __fastcall ~TEditorHack();
};

__fastcall TEditorHack::TEditorHack()
{
  //Find C++Builder's Tools menu
  TMenuItem *ToolsMenu = dynamic_cast<TMenuItem *>(
    Application->MainForm->FindComponent("ToolsMenu"));
  if (ToolsMenu)
  {
    //Make new menu item
    FEditorItem = NewItem("&Multiline Editor Tabs",
      0, false, true, DoEditorItemClick, 0, "");
    //Insert new menu item
    ToolsMenu->Insert(2, FEditorItem);
  }
}

__fastcall TEditorHack::~TEditorHack()
{
  //Restore normal editor appearance
  SetEditorItem(false);
  //Destroy editor option menu item
  delete FEditorItem;
  FEditorItem = NULL;
}

void __fastcall TEditorHack::DoEditorItemClick(TObject *Sender)
{
  //When user toggles editor menu option, set
  //checkmark and set editor state accordingly
  TMenuItem *Item = dynamic_cast<TMenuItem *>(Sender);
  if (Item)
  {
    Item->Checked = !Item->Checked;
    SetEditorItem(Item->Checked);
  }
}

void __fastcall TEditorHack::SetEditorItem(Boolean Value)
{
  //Loop through all C++Builder's forms on-screen
  for (int Loop = 0; Loop < Screen->FormCount; Loop++)
    //If we find an editor....
    if (CompareText(Screen->Forms[Loop]->ClassName(), "TEditWindow") == 0)
    {
      //...try and find the tab control...
      TTabControl *Tab = dynamic_cast<TTabControl *>(
        Screen->Forms[Loop]->FindComponent("TabControl"));
      if (Tab)
        //...and set it as requested
        Tab->MultiLine = Value;
    }
}

//---------------------------------------------------------------------------
//   Package source.
//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
  static TEditorHack *EditorHack = NULL;
  switch (reason)
  {
    case DLL_PROCESS_ATTACH: EditorHack = new TEditorHack;
    break;
    case DLL_PROCESS_DETACH: delete EditorHack;
  }

  return 1;
}
//---------------------------------------------------------------------------
